from dataclasses import dataclass


@dataclass
class PlaceLevel:
    level: int
    genus: str
    name: str
    name_gen: str
    name_acc: str
    name_loc: str
    in_prep: str

    def name_genitive(self, m="", f="", n="") -> str:
        w = {'m': m, 'f': f, 'n': n}[self.genus]
        return (w + ' ' if w is not '' else '') + self.name_gen

    def name_accusative(self, m="", f="", n="") -> str:
        w = {'m': m, 'f': f, 'n': n}[self.genus]
        return (w + ' ' if w is not '' else '') + self.name_acc

    def name_locative(self, m="", f="", n="") -> str:
        w = {'m': m, 'f': f, 'n': n}[self.genus]
        return (w + ' ' if w is not '' else '') + self.name_loc

    def in_name(self) -> str:
        return self.in_prep + ' ' + self.name_loc


place_levels = [
        PlaceLevel(level=0, genus='m', in_prep='ve',
            name='stát', name_gen='státu', name_acc='stát', name_loc='státě'),
        PlaceLevel(level=1, genus='m', in_prep='v',
            name='kraj', name_gen='kraje', name_acc='kraj', name_loc='kraji'),
        PlaceLevel(level=2, genus='m', in_prep='v',
            name='okres', name_gen='okresu', name_acc='okres', name_loc='okrese'),
        PlaceLevel(level=3, genus='f', in_prep='v',
            name='obec', name_gen='obce', name_acc='obec', name_loc='obci'),
        PlaceLevel(level=4, genus='f', in_prep='ve',
            name='škola', name_gen='školy', name_acc='školu', name_loc='škole'),
]
